<?php
/*
	SHChat
	by Scripthosting.net
	http://www.shchat.net

	Autor: Jan-Michael Fuhrmann
	info@scripthosting.net
*/

class Mail{
	
	const MAIL_VERSION = "0702";
	public $sender,$receiver,$subject,$msg;
	
	
	/**
	 * Sends an E-Mail
	 * @param String $sender
	 * @param String $receiver
	 * @param String $subject
	 * @param String $msg
	 * @return boolean
	 */
	public function sendMail( $sender, $receiver, $subject, $msg ){
		
		$mail = false;
		
		if( $this->validate($receiver) && $this->validate($sender) ){
		
			$headers  = "From: {$sender}" . "\r\n";
			$headers .= "Reply-To: {$sender}" . "\r\n";
			$headers .= "X-Mailer: PHP/" . phpversion();
		
			/* Verschicken der Mail */
			$mail = @mail($receiver, $subject, $msg, $headers);
		}
		return $mail;
	}
	
	
	/**
	 * Sends an HTML E-Mail
	 * @param String $sender
	 * @param String $receiver
	 * @param String $subject
	 * @param String $msg
	 * @return boolean
	 */
	public function sendHtmlMail( $sender, $receiver, $subject, $msg ){
		
		$mail = false;
		
		if( $this->validate($receiver) && $this->validate($sender) ){

			/* Message */
			$msg = '
			<html>
			<head>
			 <title>'.$subject.'</title>
			</head>
			<body>
			'.$msg.'
			</body>
			</html>
			';
		
			/* Mail-Headers */
			$headers  = "MIME-Version: 1.0\r\n";
			$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
			$headers .= "From: {$sender}" . "\r\n";
			$headers .= "Reply-To: {$sender}" . "\r\n";
			$headers .= "X-Mailer: PHP/" . phpversion();
		
			/* Send Mail */
			$mail = @mail($receiver, $subject, $msg, $headers);
		}
		return $mail;
	}
	
		
	/**
	 * Validates an E-Mail Adress
	 * @param $email
	 * @return boolean
	 */
	public function validate( $email ){
		
		$email_pattern = "^([0-9,a-z,A-Z]+)([.,_,-]([0-9,a-z,A-Z]+))*[@]([0-9,a-z,A-Z]+)([.,_,-]([0-9,a-z,A-Z]+))*[.]([0-9,a-z,A-Z]){2}([0-9,a-z,A-Z])?$";
		
		if( ereg($email_pattern,$email) ){
			return true;
		}
		return false;
	}
		
	
	/** 
	 * Checks if an E-Mail Adress exists
	 * @param $email
	 * @return boolean
	 */
	private function checkEmail( $email )
	{
		// checks proper syntax
		if( !$this->validate($email) ){
			return false;
		}
	
		// gets domain name
		list($username,$domain)=split('@',$email);
		// checks for if MX records in the DNS
		$mxhosts = array();
		if(!getmxrr($domain, $mxhosts))
		{
			// no mx records, ok to check domain
			if (!fsockopen($domain,25,$errno,$errstr,30)){
				return false;
			}else{
				return true;
			}
		}
		else
		{
			// mx records found
		    foreach ($mxhosts as $host)
			{
				if (fsockopen($host,25,$errno,$errstr,30)){
					return true;
				}
			}
			return false;
		}
	}
}
?>