<?php
/*
	SHChat
	by Scripthosting.net
	http://www.shchat.net

	Autor: Jan-Michael Fuhrmann
	info@scripthosting.net
*/

require_once(dirname(__FILE__)."/class.Logfile.php");
require_once(dirname(__FILE__)."/class.Chat.php");

class Mysql extends Chat {
	
	const MYSQL_VERSION = "00602";
	public $config, $result, $mysqli, $isConnected;

	
	/**
	 * Connect to the MySQL Database
	 * @return $mysqli Connection Object
	 */
	private function connect(){
		
		global $config;
		$mysqli = new Mysqli($config["host"],$config["username"],$config["userpass"],$config["database"]);
		$isConnected = ( $mysqli->error == "" ) ? true : false;
		return $mysqli;
	}
	
	
	/**
	 * Sends a MySQLi Query
	 * @param $sql
	 * @return mysqli_query Object
	 */
	public function query( $sql ){
		
		$mysqli = $this->connect();
		$query = $mysqli->query( $sql ) OR die("<p><b>MySQL meldete einen Fehler:</b> " . $mysqli->error . "</p>");
		//$logfile = new Logfile();
		//$logfile->add("query.log",$sql);
		return $mysqli;
	}
	
	
	/**
	 * Returns a MySQLi result Array
	 * @param $sql
	 * @return $result mysqli_result Object
	 */
	public function result( $sql ){

		$mysqli = $this->connect();
		$result = $mysqli->query( $sql ) OR die("<p><b>MySQL meldete einen Fehler:</b> " . $mysqli->error . "</p>");
		//$logfile = new Logfile();
		//$logfile->add("result.log",$sql);
		return $result;	
	}
	
	
	/**
	 * Close Results and/or MySQLi Connection
	 * @return void
	 */
	private function close(){
		
		@$result->close();
		@$mysqli->close();		
		return;
	}
}
?>